import { Decoder } from '@mojotech/json-type-validation';
import IOtm from './IOtm';
import IEntry from './IEntry';
import IWord from './IWord';
import IZpdic from './IZpdic';
import ITranslation from './ITranslation';
import IVariation from './IVariation';
import IContent from './IContent';
import IRelation from './IRelation';
declare class OTMJSON {
    static entryDecoder: Decoder<IEntry>;
    static translationDecoder: Decoder<ITranslation>;
    static contentDecoder: Decoder<IContent>;
    static variationDecoder: Decoder<IVariation>;
    static relationDecoder: Decoder<IRelation>;
    static wordDecoder: Decoder<IWord>;
    static zpdicDecoder: Decoder<IZpdic>;
    static otmDecoder: Decoder<IOtm>;
    static parse: (text: string, reviver?: ((this: unknown, key: string, value: unknown) => unknown) | undefined) => IOtm;
}
export default OTMJSON;
