"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const json_type_validation_1 = require("@mojotech/json-type-validation");
class OTMJSON {
}
OTMJSON.entryDecoder = json_type_validation_1.object({
    id: json_type_validation_1.number(),
    form: json_type_validation_1.string(),
});
OTMJSON.translationDecoder = json_type_validation_1.object({
    title: json_type_validation_1.string(),
    forms: json_type_validation_1.array(json_type_validation_1.string()),
});
OTMJSON.contentDecoder = json_type_validation_1.object({
    title: json_type_validation_1.string(),
    text: json_type_validation_1.string(),
});
OTMJSON.variationDecoder = json_type_validation_1.object({
    title: json_type_validation_1.string(),
    form: json_type_validation_1.string(),
});
OTMJSON.relationDecoder = json_type_validation_1.object({
    title: json_type_validation_1.string(),
    entry: OTMJSON.entryDecoder,
});
OTMJSON.wordDecoder = json_type_validation_1.object({
    entry: OTMJSON.entryDecoder,
    translations: json_type_validation_1.array(OTMJSON.translationDecoder),
    tags: json_type_validation_1.array(json_type_validation_1.string()),
    contents: json_type_validation_1.array(OTMJSON.contentDecoder),
    variations: json_type_validation_1.array(OTMJSON.variationDecoder),
    relations: json_type_validation_1.array(OTMJSON.relationDecoder),
});
OTMJSON.zpdicDecoder = json_type_validation_1.object({
    alphabetOrder: json_type_validation_1.optional(json_type_validation_1.string()),
    plainInformationTitles: json_type_validation_1.optional(json_type_validation_1.array(json_type_validation_1.string())),
    informationTitleOrder: json_type_validation_1.optional(json_type_validation_1.union(json_type_validation_1.constant(null), json_type_validation_1.array(json_type_validation_1.string()))),
    defaultWord: json_type_validation_1.optional(json_type_validation_1.union(json_type_validation_1.constant(null), OTMJSON.wordDecoder)),
});
OTMJSON.otmDecoder = json_type_validation_1.object({
    words: json_type_validation_1.array(OTMJSON.wordDecoder),
    version: json_type_validation_1.optional(json_type_validation_1.number()),
    zpdic: json_type_validation_1.optional(OTMJSON.zpdicDecoder),
});
OTMJSON.parse = (text, reviver) => OTMJSON.otmDecoder.runWithException(JSON.parse(text, reviver));
exports.default = OTMJSON;
